@echo off
cd dfilter
FOR %%v IN (%1 %2 %3 %4 %5 %6) DO if (%%v)==() goto badparam
ESPACE 800
if errorlevel=0 goto okay
type environ.txt
pause
goto end

:okay

echo %6 | nset dtemp=$1
echo %5 | nset maildir=$1

if "%2"=="inbox&" set filespec=..\%5*.cnm
if "%2"=="outbox&" set filespec=..\%5*.tbs
if "%2"=="sent&" set filespec=..\%5*.snt
if "%2"=="read&" set filespec=..\%5*.mes

set num=%4
if not "%4"=="1000" goto onefilter

xgrep -c "[:n]*" filter.txt | NSET totalfil=$1
set num=1

:onefilter
cls
nset /l%num% RST=$0 < FILTER.TXT
echo %rst% | nset subdir=$1
echo %rst% | nset /s' dtext=$2 $3 $4 $5 $6 $7 $8 $9 $10 $11 $12
echo %2 | nset /s& box=$1
echo.
echo =====================================================================
if not (%totalfil%)==() echo Running filter #%num% of %totalfil%
echo Searching for "%dtext%" in %box%
echo =====================================================================
echo.
XGREP -l -x "%dtext%" %filespec% >%dtemp%.\found.txt
if not errorlevel==1 goto found
echo  Nothing found!
echo  No %box% messages were found containing "%dtext%"
echo.
pause
goto nearend

:found
xgrep -c "[:n]*" %dtemp%.\found.txt | NSET total=$1
echo A total of %total% messages were found.
echo Here are the %box% messages which contained "%dtext%"
echo.
echo ---------- start of found.txt -------------
echo.
type %dtemp%.\found.txt
echo.
echo ----------- end of found.txt --------------
echo.

rem  If you want to automatically move any found messages,
rem  just rem out the next two lines
choix /C:YN "Do you want to move these %total% files to \arachne\%maildir%%subdir% ? "
if errorlevel=2 goto nearend

if exist ..\%maildir%%subdir%\nul goto direxists
if (%maildir%)==(mail\) goto regmail

rem If maildir is a longer path e.g mail\user1\

echo %5 | nset /s\ maildir=$1 $2 $3 $4 $5 $6 $7
set dirnum=1

:dirloop
echo %maildir% | nset /s\ mailtemp=$%dirnum%
if (%mailtemp%)==() goto dirdone
if %dirnum%==1 set dirpath=%mailtemp%
if not %dirnum%==1 set dirpath=%dirtemp%\%mailtemp%
count dirnum
if not exist ..\%dirpath%\nul md ..\%dirpath%
set dirtemp=%dirpath%
goto dirloop

:dirdone
if not exist ..\%dirpath%\nul md ..\%dirpath%
set maildir=%dirpath%
goto direxists

:regmail
if not exist ..\%maildir%%subdir%\nul md ..\%maildir%%subdir%

:direxists
set moveprog=move
fpath move > NUL
if errorlevel 1 set moveprog=mv
type %dtemp%.\found.txt | listmod /X\. %moveprog% $0 ..\%maildir%%subdir%\$2.mes > %dtemp%.\temp.bat
call %dtemp%.\temp.bat
goto nearend

:error
echo.
echo   Error - QUERY string wasn't saved or improperly formatted.
echo.
pause
goto end

:badparam
echo.
echo            Error in CGI form - Please re-renter values.
echo.
pause
goto end

:nearend

if (%totalfil%)==() goto end
if (%totalfil%)==(%num%) goto end

FOR %%v IN (found.txt temp.bat) DO if exist %dtemp%.\%%v del %dtemp%.\%%v
count num
goto onefilter

:end

FOR %%v IN (totalfil num filespec subdir rst dtext total maildir dirtemp dirpath box dirnum moveprog dtemp) DO set %%v=
FOR %%v IN (found.txt temp.bat) DO if exist %dtemp%.\%%v del %dtemp%.\%%v
cd ..
